FFplay Documentation

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 1. Synopsis

    ffplay [options] ‘input_file’

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 2. Description

FFplay is a very simple and portable media player using the FFmpeg libraries and the SDL library. It is mostly used as a testbed for the various FFmpeg APIs.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 3. Options

All the numerical options, if not specified otherwise, accept in input a string representing a number, which may contain one of the International System number postfixes, for example 'K', 'M', 'G'. If 'i' is appended after the postfix, powers of 2 are used instead of powers of 10. The 'B' postfix multiplies the value for 8, and can be appended after another postfix or used alone. This allows using for example 'KB', 'MiB', 'G' and 'B' as postfix.

Options which do not take arguments are boolean options, and set the corresponding value to true. They can be set to false by prefixing with "no" the option name, for example using "-nofoo" in the commandline will set to false the boolean option with name "foo".

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.1 Generic options

These options are shared amongst the ff* tools.

‘`-L`’

  Show license.

‘`-h, -?, -help, --help`’

  Show help.

‘`-version`’

  Show version.

‘`-formats`’

  Show available formats.

  The fields preceding the format names have the following meanings:

  ‘`D`’

    Decoding available

  ‘`E`’

    Encoding available

‘`-codecs`’

  Show available codecs.

  The fields preceding the codec names have the following meanings:

  ‘`D`’

    Decoding available

  ‘`E`’

    Encoding available

  ‘`V/A/S`’

    Video/audio/subtitle codec

  ‘`S`’

    Codec supports slices

  ‘`D`’

    Codec supports direct rendering

  ‘`T`’

    Codec can handle input truncated at random locations instead of only at frame boundaries

‘`-bsfs`’

  Show available bitstream filters.

‘`-protocols`’

  Show available protocols.

‘`-filters`’

  Show available libavfilter filters.

‘`-pix_fmts`’

  Show available pixel formats.

‘`-loglevel loglevel`’

  Set the logging level used by the library. loglevel is a number or a string containing one of the following values:

  ‘`quiet`’
  ‘`panic`’
  ‘`fatal`’
  ‘`error`’
  ‘`warning`’
  ‘`info`’
  ‘`verbose`’
  ‘`debug`’

  By default the program logs to stderr, if coloring is supported by the terminal, colors are used to mark errors and warnings. Log coloring can be disabled setting the environment variable `NO_COLOR`.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.2 Main options

‘`-x width`’

  Force displayed width.

‘`-y height`’

  Force displayed height.

‘`-s size`’

  Set frame size (WxH or abbreviation), needed for videos which don't contain a header with the frame size like raw YUV.

‘`-an`’

  Disable audio.

‘`-vn`’

  Disable video.

‘`-ss pos`’

  Seek to a given position in seconds.

‘`-t duration`’

  play <duration> seconds of audio/video

‘`-bytes`’

  Seek by bytes.

‘`-nodisp`’

  Disable graphical display.

‘`-f fmt`’

  Force format.

‘`-window_title title`’

  Set window title (default is the input filename).

‘`-loop number`’

  Loops movie playback <number> times. 0 means forever.

‘`-vf filter_graph`’

  filter_graph is a description of the filter graph to apply to the input video. Use the option "-filters" to show all the available filters (including also sources and sinks).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.3 Advanced options

‘`-pix_fmt format`’

  Set pixel format.

‘`-stats`’

  Show the stream duration, the codec parameters, the current position in the stream and the audio/video synchronisation drift.

‘`-debug`’

  Print specific debug info.

‘`-bug`’

  Work around bugs.

‘`-vismv`’

  Visualize motion vectors.

‘`-fast`’

  Non-spec-compliant optimizations.

‘`-genpts`’

  Generate pts.

‘`-rtp_tcp`’

  Force RTP/TCP protocol usage instead of RTP/UDP. It is only meaningful if you are streaming with the RTSP protocol.

‘`-sync type`’

  Set the master clock to audio (`type=audio`), video (`type=video`) or external (`type=ext`). Default is audio. The master clock is used to control audio-video synchronization. Most media players use audio as master clock, but in some cases (streaming or high quality broadcast) it is necessary to change that. This option is mainly used for debugging purposes.

‘`-threads count`’

  Set the thread count.

‘`-ast audio_stream_number`’

  Select the desired audio stream number, counting from 0. The number refers to the list of all the input audio streams. If it is greater than the number of audio streams minus one, then the last one is selected, if it is negative the audio playback is disabled.

‘`-vst video_stream_number`’

  Select the desired video stream number, counting from 0. The number refers to the list of all the input video streams. If it is greater than the number of video streams minus one, then the last one is selected, if it is negative the video playback is disabled.

‘`-sst subtitle_stream_number`’

  Select the desired subtitle stream number, counting from 0. The number refers to the list of all the input subtitle streams. If it is greater than the number of subtitle streams minus one, then the last one is selected, if it is negative the subtitle rendering is disabled.

‘`-autoexit`’

  Exit when video is done playing.

‘`-exitonkeydown`’

  Exit if any key is pressed.

‘`-exitonmousedown`’

  Exit if any mouse button is pressed.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 3.4 While playing

<q, ESC>

  Quit.

<f>

  Toggle full screen.

<p, SPC>

  Pause.

<a>

  Cycle audio channel.

<v>

  Cycle video channel.

<t>

  Cycle subtitle channel.

<w>

  Show audio waves.

<left/right>

  Seek backward/forward 10 seconds.

<down/up>

  Seek backward/forward 1 minute.

<mouse click>

  Seek to percentage in file corresponding to fraction of width.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 4. Video Filters

When you configure your FFmpeg build, you can disable any of the existing filters using –disable-filters. The configure output will show the video filters included in your build.

Below is a description of the currently available video filters.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.1 crop

Crop the input video to x:y:width:height.

    ./ffmpeg -i in.avi -vf "crop=0:0:0:240" out.avi

x and y specify the position of the top-left corner of the output (non-cropped) area.

The default value of x and y is 0.

The width and height parameters specify the width and height of the output (non-cropped) area.

A value of 0 is interpreted as the maximum possible size contained in the area delimited by the top-left corner at position x:y.

For example the parameters:

    "crop=100:100:0:0"

will delimit the rectangle with the top-left corner placed at position 100:100 and the right-bottom corner corresponding to the right-bottom corner of the input image.

The default value of width and height is 0.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.2 format

Convert the input video to one of the specified pixel formats. Libavfilter will try to pick one that is supported for the input to the next filter.

The filter accepts a list of pixel format names, separated by “:”, for example “yuv420p:monow:rgb24”.

The following command:

    ./ffmpeg -i in.avi -vf "format=yuv420p" out.avi

will convert the input video to the format “yuv420p”.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.3 noformat

Force libavfilter not to use any of the specified pixel formats for the input to the next filter.

The filter accepts a list of pixel format names, separated by “:”, for example “yuv420p:monow:rgb24”.

The following command:

    ./ffmpeg -i in.avi -vf "noformat=yuv420p, vflip" out.avi

will make libavfilter use a format different from “yuv420p” for the input to the vflip filter.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.4 null

Pass the source unchanged to the output.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.5 pad

Add paddings to the input image, and places the original input at the given coordinates x, y.

It accepts the following parameters: width:height:x:y:color.

Follows the description of the accepted parameters.

‘`width, height`’

  Specify the size of the output image with the paddings added. If the value for width or height is 0, the corresponding input size is used for the output.

  The default value of width and height is 0.

‘`x, y`’

  Specify the offsets where to place the input image in the padded area with respect to the top/left border of the output image.

  The default value of x and y is 0.

‘`color`’

  Specify the color of the padded area, it can be the name of a color (case insensitive match) or a 0xRRGGBB[AA] sequence.

  The default value of color is “black”.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.6 scale

Scale the input video to width:height and/or convert the image format.

For example the command:

    ./ffmpeg -i in.avi -vf "scale=200:100" out.avi

will scale the input video to a size of 200x100.

If the input image format is different from the format requested by the next filter, the scale filter will convert the input to the requested format.

If the value for width or height is 0, the respective input size is used for the output.

If the value for width or height is -1, the scale filter will use, for the respective output size, a value that maintains the aspect ratio of the input image.

The default value of width and height is 0.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.7 slicify

Pass the images of input video on to next video filter as multiple slices.

    ./ffmpeg -i in.avi -vf "slicify=32" out.avi

The filter accepts the slice height as parameter. If the parameter is not specified it will use the default value of 16.

Adding this in the beginning of filter chains should make filtering faster due to better use of the memory cache.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.8 unsharp

Sharpen or blur the input video.

It accepts the following parameters: luma_msize_x:luma_msize_y:luma_amount:chroma_msize_x:chroma_msize_y:chroma_amount

Negative values for the amount will blur the input video, while positive values will sharpen. All parameters are optional and default to the equivalent of the string '5:5:1.0:0:0:0.0'.

‘`luma_msize_x`’

  Set the luma matrix horizontal size. It can be an integer between 3 and 13, default value is 5.

‘`luma_msize_y`’

  Set the luma matrix vertical size. It can be an integer between 3 and 13, default value is 5.

‘`luma_amount`’

  Set the luma effect strength. It can be a float number between -2.0 and 5.0, default value is 1.0.

‘`chroma_msize_x`’

  Set the chroma matrix horizontal size. It can be an integer between 3 and 13, default value is 0.

‘`chroma_msize_y`’

  Set the chroma matrix vertical size. It can be an integer between 3 and 13, default value is 0.

‘`luma_amount`’

  Set the chroma effect strength. It can be a float number between -2.0 and 5.0, default value is 0.0.

    # Strong luma sharpen effect parameters
    unsharp=7:7:2.5

    # Strong blur of both luma and chroma parameters
    unsharp=7:7:-2:7:7:-2

    # Use the default values with ffmpeg
    ./ffmpeg -i in.avi -vf "unsharp" out.mp4

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 4.9 vflip

Flip the input video vertically.

    ./ffmpeg -i in.avi -vf "vflip" out.avi

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 5. Video Sources

Below is a description of the currently available video sources.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 5.1 nullsrc

Null video source, never return images. It is mainly useful as a template and to be employed in analysis / debugging tools.

It accepts as optional parameter a string of the form width:height, where width and height specify the size of the configured source.

The default values of width and height are respectively 352 and 288 (corresponding to the CIF size format).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 6. Video Sinks

Below is a description of the currently available video sinks.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 6.1 nullsink

Null video sink, do absolutely nothing with the input video. It is mainly useful as a template and to be employed in analysis / debugging tools.

[Top] | [Contents] | [Index] | [ ? ]

# About This Document

This document was generated on July, 7 2010 using texi2html 1.78.

The buttons in the navigation panels have the following meaning:

Button | Name | Go to | From 1.2.3 go to
--- | --- | --- | ---
[ < ] | Back | Previous section in reading order | 1.2.2
[ > ] | Forward | Next section in reading order | 1.2.4
[ << ] | FastBack | Beginning of this chapter or previous chapter | 1
[ Up ] | Up | Up section | 1.2
[ >> ] | FastForward | Next chapter | 2
[Top] | Top | Cover (top) of document |
[Contents] | Contents | Table of contents |
[Index] | Index | Index |
[ ? ] | About | About (help) |

where the Example assumes that the current position is at Subsubsection One-Two-Three of a document of the following structure:

- 1. Section One
  - 1.1 Subsection One-One
    - ...
  - 1.2 Subsection One-Two
    - 1.2.1 Subsubsection One-Two-One
    - 1.2.2 Subsubsection One-Two-Two
    - 1.2.3 Subsubsection One-Two-Three <== Current Position
    - 1.2.4 Subsubsection One-Two-Four
  - 1.3 Subsection One-Three
    - ...
  - 1.4 Subsection One-Four

This document was generated on July, 7 2010 using texi2html 1.78.